﻿# ##########################################################################
# Programme Python permettant de tracer les positions d'un point M
# à partir d'abscisses et d'ordonnées issues d'un pointage (ou d'équations).
# et de tracer le vecteur variation vitesse en un point
# à destination des élèves qui peuvent modifier le code sous les parties roses

# L'utilisation des listes NUMPY permet de simplifier le code
# ##########################################################################
# O. CHAUMETTE - Lycée JP SARTRE - 69500 BRON - olivier.chaumette@ac-lyon.fr
# ##########################################################################


# ##########################
# IMPORTATION DES MODULES #
# #########################
# importation de NUMPY (pour gestion tableaux et calculs) sous l'alias "np"
import numpy as np
# importation de PYPLOT (du module MATPLOTLIB, pour le tracé de courbes) sous l'alias "plt"
import matplotlib.pyplot as plt

# modules permettant d'importer des données
# le fichier "import_donnees2.py" est indispensable
# (version 2 avec bonnes équations horaires)
from import_donnees_meca2 import traiteDonnees


# Initialisation des tableaux numpy contenant x,y,t et les coordonnées des vitesses
x=np.array([])
y=np.array([])
t=np.array([])
Vx=np.array([])
Vy=np.array([])

# #################################
# Fonction qui simplifie le tracé du vecteur vitesse
# afin que l'élève n'ait pas à définir l'origine
# du vecteur en termes de coordonnées
# (pour ne pas mélanger des positions et des coordonées de vecteurs)
# #################################
def draw_Vector2(numero_du_point, abscisse_vecteur, ordonnee_vecteur, couleur,echelle):
    global x,y
    plt.quiver(x[numero_du_point], y[numero_du_point],abscisse_vecteur,ordonnee_vecteur,color=couleur,scale=echelle)


""" ---------------------------------
        CHOIX du PROFESSEUR
------------------------------------- """
#  Logiciel utilisé à choisir parmi :
# 'pymecavideo'     (exporter un fichier TXT)
# 'latispro'        (fichier TXT créé par LATISPRO, avec décimale VIRGULE et séparation POINT VIRGULE)
# 'avimeca'         (crééer un fichier TXT en export)
# 'avistep'         (pointage exporté depuis AVISTEP:
# 'equation'        (équation paramétrées saisies dans le fichier "import_donnees2")
# 'entrees'        (données de pointage saisies "à la main" dans le fichier "import_donnees2.py)

Logiciel_Utilise = 'latispro'

""" ---------------------------------
        FIN du CHOIX du PROFESSEUR
------------------------------------- """

t, x, y = traiteDonnees(Logiciel_Utilise)
Nbre_Mesures=len(x)


""" ###########################################
Ici commence le travail à réaliser par les élèves
################################################# """
# #####################################
# Tracé de la trajectoire
# #####################################
""" TRAVAIL 1:
Taper ci-dessous le code Python permettant de tracer l'ordonnée du point en fonction de son abscisse. """
plt.plot(x,y,"+r")


""" TRAVAIL 2:
taper, à la place des points entre guillemets, les légendes pour les axes,
le titre du graphique"""
plt.title("Trajectoire du point point M")          # titre du graphique
plt.xlabel("Abscisse X du système (en m)")         # nom de la grandeur sur l'axe X
plt.ylabel("Ordonnée Y du système (en m)")         # nom de la grandeur sur l'axe Y


# #####################################
# Vecteur vitesse
# #####################################
""" TRAVAIL 3:
Taper, DANS LA BOUCLE ci-dessous, le code python permettant:
    - d'ajouter au tableau Vx l'abscisse du vecteur vitesse au point numéro "n"
    - d'ajouter au tableau Vx l'abscisse du vecteur vitesse au point numéro "n" """
for n in range (1,Nbre_Mesures-1):
    Vx=np.append(Vx,(x[n+1]-x[n-1])/(t[n+1]-t[n-1]))
    Vy=np.append(Vy,(y[n+1]-y[n-1])/(t[n+1]-t[n-1]))
    draw_Vector2(n,Vx[n-1],Vy[n-1],"b",20)


""" ne pas toucher à la ligne ci-dessous """
Nbre_vitesses=len(Vx)           # nombre de vitesses disponibles.
                                # Remarque: Nbre_vitesses=Nre_mesures-2
                                # puisque pour le calcul de Vx, Vy, on ne prend pas le
                                # 1er et le dernier point

# #####################################
# Vecteur variation de vitesse
# #####################################
""" TRAVAIL 4:
Taper ci-dessous le code python permettant:
    - de créer une boucle (compteur de boucle nommé "n") allant de 1 à Nbre_vitesses-1
    - de mettre dans une variable DeltaVx l'abscisse du vecteur variation de vitesse au point n
    - de mettre dans une variable DeltaVy l'ordonnée du vecteur variation de vitesse au point n
    - de tracer le vecteur variation vitesse au point "n+1" en vert avec une échelle de 5"""
for n in range(1,Nbre_vitesses-1):
    DeltaVx=Vx[n+1]-Vx[n-1]
    DeltaVy=Vy[n+1]-Vy[n-1]
    draw_Vector2(n+1,DeltaVx,DeltaVy,"g",5)


""" fin du travail """


# On affiche une grille
plt.grid()
# le repère doit être orthonormé:
plt.axis('equal')
# on affiche la fenêtre
#plt.get_current_fig_manager().window.state('zoomed')   # <-- Affiche la fenêtre maximisée sous windows uniquement
plt.show()
